#ifndef INCLUDED_TCL_CURVE_EDITOR_H
#define INCLUDED_TCL_CURVE_EDITOR_H

#pragma warning(disable : 4786)

#include <tcl.h>

#include <string>

extern "C"
{
	int __declspec(dllexport) Curveeditor_Init(Tcl_Interp * interpreter);
	
	int CurveEditor_Initialization(Tcl_Interp * interpreter);

	int CurveEditor_ResizeCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_RedrawCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_MouseButtonDownCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_MouseAltClickCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_MouseControlClickCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_MouseDragCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_MouseButtonUpCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_ShiftMouseButtonDownCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_ShiftMouseDragCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_ShiftMouseButtonUpCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_GetCurveNamesCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_GetCurveTypesCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_UpdateCurveCurrentPositionsCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_SetCurrentlySelectedCurveTypeCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_ToggleShowAnimationCurveCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_ToggleWrapControlPointsCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_AddCurveCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_ClearCurvesCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_LoadCurvesCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_SaveCurvesCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_GetMinimumTimeCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_GetMaximumTimeCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_GetMinimumValueCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_GetMaximumValueCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_GetTimeCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_GetCurrentlySelectedCurveNameCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_TryPopZoomCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);
	
	int CurveEditor_ChangeAnimationLengthCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_RescaleTimeCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_ChangeMinimumYCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	int CurveEditor_ChangeMaximumYCommand(ClientData client_data, Tcl_Interp * interpreter, int object_count, Tcl_Obj * const objects[]);

	void CurveEditor_UpdateTclVariables(Tcl_Interp * interpreter);
}

#endif